/* --------------------------------------- */
/* By Andy Carvell - andy@burningimage.net */
/* --------------------------------------- */

#include <stdio.h>
#include <string.h>

#include "radio.h"
#include "microchiptx.h"

void sendcode(char* code);

int main(int argc, char **argv)
{
	char codeon[] =  "1010101010101011000110100110100110010101100101010110010101010110011010011";
	char codeoff[] = "1010101010101011000110100110100110010101100101010101010101011001011010011";

	if (argc == 2)
	{

		setup_io();
		enabletx();
		if (!strcmp(argv[1],"on"))
		{
			sendcode(codeon);
		}
		else
		{
			sendcode(codeoff);
		}
	}

	disabletx();
}

void sendcode(char* code)
{
	int i, j;
	for (i=0; i<5; i++)
	{
		for (j=0; j<strlen(code); j++)
		{
			if (code[j] == '1')
			{
				askon();
			}
			else
			{
				askoff();
			}
			usleep(432);
		}
		askoff();
		usleep(1000000);
	}
}
