<?php 
/////////////////////////////////////////////////////////////////////////////
//
// AUTHENTICATE PAGE
//
//   Server-side:
//     1. Get the challenge from the user session
//     2. Get the password for the supplied user (local lookup)
//     3. Compute expected_response = MD5(challenge+password)
//     4. If expected_response == supplied response:
//        4.1. Mark session as authenticated and forward to pi.php
//        4.2. Otherwise, authentication failed. Go back to index.php
//////////////////////////////////////////////////////////////////////////////////

require("logwrite.php");

$userDB = array(
	"user" => "password",
	"user2" => "password");

function getPasswordForUser($username)
{
// get password from a simple associative array
// but this could be easily rewritten to fetch user info from a real DB
	global $userDB;     return $userDB[$username];
}

function validate($challenge, $response, $password)
{
	return md5($challenge . $password) == $response;
}

function authenticate()
{
	if (isset($_SESSION['challenge']) &&
		isset($_REQUEST['username']) &&
		isset($_REQUEST['response']))
	{
		$password = getPasswordForUser($_REQUEST['username']);
		if (validate($_SESSION['challenge'], $_REQUEST['response'], $password))
		{
			$_SESSION['authenticated'] = "yes";
			$_SESSION['username'] = $_REQUEST['username'];
			unset($_SESSION['challenge']);
			attemptlog("Successful authentication using username ".$_REQUEST['username']);
		}
		else
		{
			attemptlog("Failed authentication using username ".$_REQUEST['username']);
			if (isset($_REQUEST['page'])) header("Location:login.php?page=".$_REQUEST['page']."&error=".urlencode("Failed authentication"));
			else header("Location:login.php?error=".urlencode("Failed authentication"));
		}
	}
	else
	{
		if (isset($_REQUEST['page'])) header("Location:login.php?page=".$_REQUEST['page']."&error=".urlencode("Session expired"));
		else header("Location:login.php?error=".urlencode("Session expired"));
	}
}

session_start();
authenticate();

if (isset($_REQUEST['page']) && ($_REQUEST['page'] != ""))
{
	header("Location:".$_REQUEST['page']);
}
else
{
	header("Location:index.php");
}

exit();

?>
