/* --------------------------------------- */
/* By Andy Carvell - andy@burningimage.net */
/* --------------------------------------- */

#include <stdio.h>

#include "microchiptx.h"
#include "radio.h"

void enabletx(void)
{
	// Enable transmitter and ASK pin
	INP_GPIO(ENABLE_TX_PIN);
	OUT_GPIO(ENABLE_TX_PIN);
	INP_GPIO(ASK_TX_PIN);
	OUT_GPIO(ASK_TX_PIN);

	GPIO_SET = 1 << ENABLE_TX_PIN;
}

void disabletx(void)
{
	// Disable transmitter
	GPIO_CLR = 1 << ENABLE_TX_PIN;
}

void askon(void)
{
	GPIO_SET = 1 << ASK_TX_PIN;
}

void askoff(void)
{
	GPIO_CLR = 1 << ASK_TX_PIN;
}
